Create an Invoice
Scopes: invoice:create
curl --request POST \
--url https://api.sandbox.getasset.com/v0/business/{business_id}/invoice \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
[
{
"number": "INV-001",
"description": "Web development services",
"due_at": "2025-02-15T00:00:00Z",
"sent_at": "2025-01-15T00:00:00Z",
"lines": [
{
"description": "Web development services",
"amount": 520.56,
"ledger_id": "<string>",
"metadata": {}
}
],
"external_id": "inv-2025-01-15-001",
"currency": "USD",
"customer_id": "cus_WQMDNUHpBThYSNh4AprDBo",
"customer_external_id": "cust_ext_001",
"metadata": {},
"tags": {
"Location": "NYC"
}
}
]
'import requests
url = "https://api.sandbox.getasset.com/v0/business/{business_id}/invoice"
payload = [
{
"number": "INV-001",
"description": "Web development services",
"due_at": "2025-02-15T00:00:00Z",
"sent_at": "2025-01-15T00:00:00Z",
"lines": [
{
"description": "Web development services",
"amount": 520.56,
"ledger_id": "<string>",
"metadata": {}
}
],
"external_id": "inv-2025-01-15-001",
"currency": "USD",
"customer_id": "cus_WQMDNUHpBThYSNh4AprDBo",
"customer_external_id": "cust_ext_001",
"metadata": {},
"tags": { "Location": "NYC" }
}
]
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify([
{
number: 'INV-001',
description: 'Web development services',
due_at: '2025-02-15T00:00:00Z',
sent_at: '2025-01-15T00:00:00Z',
lines: [
{
description: 'Web development services',
amount: 520.56,
ledger_id: '<string>',
metadata: {}
}
],
external_id: 'inv-2025-01-15-001',
currency: 'USD',
customer_id: 'cus_WQMDNUHpBThYSNh4AprDBo',
customer_external_id: 'cust_ext_001',
metadata: {},
tags: {Location: 'NYC'}
}
])
};
fetch('https://api.sandbox.getasset.com/v0/business/{business_id}/invoice', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"data": [
{
"business_id": "biz_Pk2fNFDd8wj7EFeLWJywc7",
"number": "INV-1234567890",
"description": "Invoice from Acme Corp",
"total_amount": 520.56,
"source": "manual",
"due_at": "2023-11-07T05:31:56Z",
"sent_at": "2023-11-07T05:31:56Z",
"status": "paid",
"id": "inv_GkBo16N66u2teKfFuFMMwf",
"customer_id": "cus_WxcM3ypJ5boFxsNQzcqRXe",
"currency": "CAD",
"external_id": "inv-2025-01-15-001",
"total_paid": 520.56,
"voided_at": "2023-11-07T05:31:56Z",
"metadata": {},
"lines": [
{
"description": "Web development services",
"ledger_id": "ldg_ErisumsAc7qgmbTctM7zKK",
"amount": 520.56,
"id": "inl_GkBo16N66u2teKfFuFMMwf",
"invoice_id": "inv_WQMDNUHpBThYSNh4AprDBo",
"metadata": {}
}
],
"payments": [
{
"invoice_id": "inv_GkBo16N66u2teKfFuFMMwf",
"payment_id": "inp_ErisumsAc7qgmbTctM7zKK",
"datetime": "2021-01-01T00:00:00Z",
"payment_amount": 520.56,
"id": "inp_WQMDNUHpBThYSNh4AprDBo",
"transaction_id": "txn_WQMDNUHpBThYSNh4AprDBo",
"credit_journal_entry_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"credit_memo_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"invoice": "<unknown>",
"is_write_off": false
}
],
"tags": {
"Job": [
{
"amount": "3000.00",
"value": "Maple Street Remodel"
},
{
"amount": "1500.00",
"value": "Downtown Office Rewire"
}
]
}
}
],
"errors": [
{
"error": "<string>",
"invoice_number": "<string>",
"external_id": "inv-2025-01-15-001"
}
]
}{
"error": "<string>",
"data": "<unknown>"
}{
"error": "<string>",
"data": "<unknown>"
}{
"error": "<string>",
"data": "<unknown>"
}{
"error": "<string>",
"data": "<unknown>"
}{
"error": "<string>",
"data": "<unknown>"
}Authorizations
The access token received from the authorization server in the OAuth 2.0 flow.
- Token URL
- /v0/auth/token
Headers
Optional external entity identifier that performed the action
Path Parameters
The id of the business
"biz_GA6EG2qFxA97NZHtxeLPUy"
Body
100The number of the invoice
255"INV-001"
The description of the invoice
512"Web development services"
The due date of the invoice in ISO-8601 format
"2025-02-15T00:00:00Z"
The date the invoice was sent in ISO-8601 format
"2025-01-15T00:00:00Z"
The lines of the invoice
Show child attributes
Show child attributes
An optional external identifier for the invoice. Must be unique across all invoices for a business.
255"inv-2025-01-15-001"
ISO 4217 currency code for this invoice.
3"USD"
The ID of the Customer that the invoice is associated with. Required if customer_external_id is not provided.
"cus_WQMDNUHpBThYSNh4AprDBo"
The external ID of the Customer that the invoice is associated with. Required if customer_id is not provided.
255"cust_ext_001"
Inline tag input. Each field maps to either a single value (string, e.g. 'NYC') or a list of {value, amount} objects to allocate the invoice across multiple values. The tag field must already exist; values are created automatically if missing. Per-field sum of amounts must not exceed the invoice total.
Show child attributes
Show child attributes
{ "Location": "NYC" }
